Package: mclustcomp
Type: Package
Title: Measures for Comparing Clusters
Version: 0.3.5
Authors@R: person("Kisung", "You", email = "kisung.you@outlook.com", role = c("aut", "cre"))
Description: Given a set of data points, a clustering is defined as a disjoint partition
    where each pair of sets in a partition has no overlapping elements. 
    This package provides 25 methods that play a role somewhat similar to 
    distance or metric that measures similarity of two clusterings - or partitions.
    For a more detailed description, see Meila, M. (2005) <doi:10.1145/1102351.1102424>.
License: MIT + file LICENSE
Encoding: UTF-8
Imports: Rcpp, Rdpack
LinkingTo: Rcpp, RcppArmadillo
RoxygenNote: 7.3.2
RdMacros: Rdpack
NeedsCompilation: yes
Packaged: 2025-09-22 01:24:16 UTC; kyou
Author: Kisung You [aut, cre]
Maintainer: Kisung You <kisung.you@outlook.com>
Repository: CRAN
Date/Publication: 2025-09-22 07:20:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-26 00:09:28 UTC; unix
Archs: mclustcomp.so.dSYM

Package: mclustcomp
Type: Package
Title: Measures for Comparing Clusters
Version: 0.3.5
Authors@R: person("Kisung", "You", email = "kisung.you@outlook.com", role = c("aut", "cre"))
Description: Given a set of data points, a clustering is defined as a disjoint partition
    where each pair of sets in a partition has no overlapping elements. 
    This package provides 25 methods that play a role somewhat similar to 
    distance or metric that measures similarity of two clusterings - or partitions.
    For a more detailed description, see Meila, M. (2005) <doi:10.1145/1102351.1102424>.
License: MIT + file LICENSE
Encoding: UTF-8
Imports: Rcpp, Rdpack
LinkingTo: Rcpp, RcppArmadillo
RoxygenNote: 7.3.2
RdMacros: Rdpack
NeedsCompilation: yes
Packaged: 2025-09-22 01:24:16 UTC; kyou
Author: Kisung You [aut, cre]
Maintainer: Kisung You <kisung.you@outlook.com>
Repository: CRAN
Date/Publication: 2025-09-22 07:20:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->
mclustcomp
==========

[![CRAN\_Status\_Badge](http://www.r-pkg.org/badges/version/mclustcomp?color=green)](https://cran.r-project.org/package=mclustcomp) [![Travis-CI Build Status](https://travis-ci.org/kisungyou/mclustcomp.svg?branch=master)](https://travis-ci.org/kisungyou/mclustcomp) [![](https://cranlogs.r-pkg.org/badges/mclustcomp)](https://cran.r-project.org/package=mclustcomp)

Installation
------------

You can install the released version of mclustcomp from [CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("mclustcomp")
```

or the development version from github:

``` r
## install.packages("devtools")
## library(devtools)
devtools::install_github("kisungyou/mclustcomp")
```

<!-- README.md is generated from README.Rmd. Please edit that file -->

# mclustcomp

[![CRAN_Status_Badge](http://www.r-pkg.org/badges/version/mclustcomp?color=green)](https://cran.r-project.org/package=mclustcomp)
[![](https://cranlogs.r-pkg.org/badges/mclustcomp)](https://cran.r-project.org/package=mclustcomp)

## Installation

You can install the released version of mclustcomp from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("mclustcomp")
```

or the development version from github:

``` r
## install.packages("devtools")
## library(devtools)
devtools::install_github("kisungyou/mclustcomp")
```

# AUXILIARY FUNCTIONS
# 1. conversion : input type conversion


# 1. aux.conversion -------------------------------------------------------
#' @keywords internal
#' @noRd
aux.conversion <- function(x){
  if (is.character(x)){
    x = as.numeric(as.factor(unlist(strsplit(x,split=""))))
  } else if (is.factor(x)){
    x = as.numeric(x)
  } else {
    x = as.numeric(as.factor(x))
  }
  return(round(x))
}

#' Measures for Comparing Clusterings
#'
#' Given two partitions or clusterings \eqn{C_1} and \eqn{C_2}, it returns community comparison scores
#' corresponding with a set of designated methods. Note that two label vectors should be
#' of same length having either numeric or factor type. Currently we have 3 classes of methods
#' depending on methodological philosophy behind each. See below for the taxonomy.
#'
#' @section Category 1. Counting Pairs:
#' \tabular{cl}{
#' TYPE \tab FULL NAME \cr
#' \code{'adjrand'}  \tab \href{https://en.wikipedia.org/wiki/Rand_index}{Adjusted Rand index}.\cr
#' \code{'chisq'}    \tab \href{https://en.wikipedia.org/wiki/Chi-squared_test}{Chi-Squared Coefficient}.\cr
#' \code{'fmi'}      \tab \href{https://en.wikipedia.org/wiki/Fowlkes-Mallows_index}{Fowlkes-Mallows index}.\cr
#' \code{'jaccard'}  \tab \href{https://en.wikipedia.org/wiki/Jaccard_index}{Jaccard index}.\cr
#' \code{'mirkin'}   \tab Mirkin Metric, or Equivalence Mismatch Distance. \cr
#' \code{'overlap'}  \tab \href{https://en.wikipedia.org/wiki/Overlap_coefficient}{Overlap Coefficient}, or Szymkiewicz-Simpson coefficient.\cr
#' \code{'pd'}       \tab Partition Difference.\cr
#' \code{'rand'}     \tab \href{https://en.wikipedia.org/wiki/Rand_index}{Rand Index}.\cr
#' \code{'sdc'}      \tab \href{https://en.wikipedia.org/wiki/Sorensen-Dice_coefficient}{Sørensen–Dice Coefficient}.\cr
#' \code{'smc'}      \tab \href{https://en.wikipedia.org/wiki/Simple_matching_coefficient}{Simple Matching Coefficient}.\cr
#' \code{'tanimoto'} \tab \href{https://en.wikipedia.org/wiki/Jaccard_index}{Tanimoto index}.\cr
#' \code{'tversky'}  \tab \href{https://en.wikipedia.org/wiki/Tversky_index}{Tversky index}.\cr
#' \code{'wallace1'} \tab Wallace Criterion Type 1.\cr
#' \code{'wallace2'} \tab Wallace Criterion Type 2.
#' }
#' Note that Tanimoto Coefficient and Dice's coefficient are special cases with (alpha,beta) = (1,1) and (0.5,0.5), respectively.
#'
#' @section Category 2. Set Overlaps/Matching:
#' \tabular{cl}{
#' TYPE \tab FULL NAME \cr
#' \code{'f'}   \tab F-Measure. \cr
#' \code{'mhm'} \tab Meila-Heckerman Measure. \cr
#' \code{'mmm'} \tab Maximum-Match Measure. \cr
#' \code{'vdm'} \tab Van Dongen Measure.
#' }
#'
#' @section Category 3. Information Theory:
#' \tabular{cl}{
#' TYPE \tab FULL NAME \cr
#' \code{'jent'} \tab \href{https://en.wikipedia.org/wiki/Joint_entropy}{Joint Entropy} \cr
#' \code{'mi'}   \tab Mutual Information. \cr
#' \code{'nmi1'} \tab \href{https://en.wikipedia.org/wiki/Mutual_information}{Normalized Mutual Information} by Strehl and Ghosh. \cr
#' \code{'nmi2'} \tab \href{https://en.wikipedia.org/wiki/Mutual_information}{Normalized Mutual Information} by Fred and Jain. \cr
#' \code{'nmi3'} \tab Normalized Mutual Information by Danon et al. \cr
#' \code{'nvi'}  \tab Normalized Variation of Information. \cr
#' \code{'vi'}   \tab \href{https://en.wikipedia.org/wiki/Variation_of_information}{Variation of Information}.
#' }
#'
#' @param x,y vectors of clustering labels
#' @param types \code{"all"} for returning scores for every available measure.
#' Either a single score name or a vector of score names can be supplied. See the section
#' for the list of the methods for details.
#' @param tversky.param a list of parameters for Tversky index; \code{alpha} and \code{beta} for
#' weight parameters, and \code{sym}, a logical where \code{FALSE} stands for original method, \code{TRUE}
#' for a revised variant to symmetrize the score. Default (alpha,beta)=(1,1).
#'
#' @return a data frame with columns \code{types} and corresponding \code{scores}.
#'
#' @examples
#' ## example 1. compare two identical clusterings
#' x = sample(1:5,20,replace=TRUE) # label from 1 to 5, 10 elements
#' y = x                           # set two labels x and y equal
#' mclustcomp(x,y)                 # show all results
#'
#' ## example 2. selection of a few methods
#' z = sample(1:4,20,replace=TRUE)           # generate a non-trivial clustering
#' cmethods = c("jaccard","tanimoto","rand") # select 3 methods
#' mclustcomp(x,z,types=cmethods)            # test with the selected scores
#'
#' ## example 3. tversky.param
#' tparam = list()                           # create an empty list
#' tparam$alpha = 2
#' tparam$beta  = 3
#' tparam$sym   = TRUE
#' mclustcomp(x,z,types="tversky")           # default set as Tanimoto case.
#' mclustcomp(x,z,types="tversky",tversky.param=tparam)
#'
#'
#' @references
#' \insertRef{strehl_cluster_2003}{mclustcomp}
#'
#' \insertRef{meila_comparing_2007}{mclustcomp}
#'
#' \insertRef{goos_comparing_2003}{mclustcomp}
#'
#' \insertRef{wagner_comparing_2007}{mclustcomp}
#'
#' \insertRef{albatineh_similarity_2006}{mclustcomp}
#'
#' \insertRef{mirkin_eleven_2001}{mclustcomp}
#'
#' \insertRef{rand_objective_1971}{mclustcomp}
#'
#' \insertRef{kuncheva_using_2004}{mclustcomp}
#'
#' \insertRef{fowlkes_method_1983}{mclustcomp}
#'
#' \insertRef{dongen_performance_2000}{mclustcomp}
#'
#' \insertRef{jaccard_distribution_1912}{mclustcomp}
#'
#' \insertRef{li_combining_2010}{mclustcomp}
#'
#' \insertRef{larsen_fast_1999}{mclustcomp}
#'
#' \insertRef{meila_experimental_2001}{mclustcomp}
#'
#' \insertRef{cover_elements_2006}{mclustcomp}
#'
#' \insertRef{ana_robust_2003}{mclustcomp}
#'
#' \insertRef{wallace_comment_1983}{mclustcomp}
#'
#' \insertRef{simpson_mammals_1943}{mclustcomp}
#'
#' \insertRef{dice_measures_1945}{mclustcomp}
#'
#' \insertRef{segaran_programming_2007}{mclustcomp}
#'
#' \insertRef{tversky_features_1977}{mclustcomp}
#'
#' \insertRef{danon_comparing_2005}{mclustcomp}
#'
#' \insertRef{lancichinetti_detecting_2009}{mclustcomp}
#'
#' @export
mclustcomp <- function(x,y,types="all",tversky.param=list()){
  #------------------------------------------------------------------------
  ## PREPROCESSING
  #   1. size argument
  if ((!is.vector(x))||(!is.vector(y))){
    stop("* mclustcomp : input 'x' and 'y' should both be a vector of class labels.")
  }
  n = length(x)
  if (length(y)!=n){
    stop("* mclustcomp : two vectors should be of same size.")
  }

  #   2. type conversion and unique vector
  x  = aux.conversion(x)
  y  = aux.conversion(y)
  ux = unique(x)
  uy = unique(y)

  if (length(ux)==1){    warning("* mclustcomp : 'x' is a trivial clustering.")  }
  if (length(uy)==1){    warning("* mclustcomp : 'y' is a trivial clustering.")  }
  if (length(ux)==n){    warning("* mclustcomp : 'x' is the singleton clustering.")  }
  if (length(uy)==n){    warning("* mclustcomp : 'y' is the singleton clustering.")  }

  #   3. tversky parameter
  listdot = as.list(environment())
  if ("tversky.param" %in% names(listdot)){
    tversky.param = listdot$tversky.param
  } else {
    tversky.param = list()
  }
  if (!("alpha" %in% names(tversky.param))){tversky.param$alpha = 1}
  if (!("beta" %in% names(tversky.param))){tversky.param$beta = 1}
  if (!("sym" %in% names(tversky.param))){tversky.param$sym = FALSE}
  if (tversky.param$alpha < 0){stop("* mclustcomp : tversky.param$alpha should be >= 0.")}
  if (tversky.param$beta < 0){stop("* mclustcomp : tversky.param$beta should be >= 0.")}
  if (!is.logical(tversky.param$sym)){stop("* mclustcomp : tversky.param$sym should
                                           be a logical variable; FALSE for original Tversky index, TRUE for a variant.")}


  #------------------------------------------------------------------------
  ## PRELIMINARY COMPUTATIONS
  ## Prelim1 : CONFUSION MATRIX of size(length(ux),length(uy))
  confmat = get.confusion(x,y,ux,uy)
  ## Prelim2 : size of each cluster
  scx = get.commsize(x,ux)
  scy = get.commsize(y,uy)
  ## Prelim3 : comembership matrix of (2,2)
  pairmat = get.pair(x,y)

  ## Prelim4 : probability-related stuffs for Mutual Information
  threps = min(1e-10,10*(.Machine$double.eps))
  probs  = get.probs(confmat,scx,scy,n,threps)

  ## Control : type.out
  ## Case 1  : Single Argument
  ##  {"all" or single name}
  ## Case 2  : a vector of names; c("f","rand")
  type_allnames = c("adjrand","chisq","f","fmi","jaccard","mhm","mirkin","mmm",
                    "mi","nmi1","nmi2","nmi3","overlap","pd","rand","sdc","smc","tanimoto",
                    "tversky","vdm","vi","wallace1","wallace2","jent","nvi")
  type_out   = unique(types)
  if ("all" %in% type_out){
    type_test = sort(type_allnames)
  } else {
    type_test = sort(type_out)  # this type test is the one we should generate again
  }

  #------------------------------------------------------------------------
  ## MAIN COMPUTATION
  type_score = rep(0,length(type_test))
  for (i in 1:length(type_test)){
    type_score[i] = mclustsingle(n,x,y,ux,uy,scx,scy,confmat,pairmat,probs,threps,type_test[i],tversky.param)
  }

  #------------------------------------------------------------------------
  ## RETURN RESULTS
  result = data.frame(types=type_test,scores=type_score)
  return(result)
}



# COMPUTE :: single measure branching -------------------------------------
## Original Implementation of 19 methods
mclustsingle <- function(n,x,y,ux,uy,scx,scy,confmat,pairmat,probs,threps,type,tversky.param){
  # Missing parameters for score08_mmm
  nk = length(scx)
  nl = length(scy)
  # Sepearting probs for NMI and VIs
  Ixy = probs$Ixy
  Hx  = probs$Hx
  Hy  = probs$Hy
  Pxy = (confmat/n)  # joint probability matrix + correction
  Pxy[(Pxy<min(threps))] = min(threps)
  # Tversky parameter
  t.alpha = tversky.param$alpha
  t.beta  = tversky.param$beta
  t.sym   = tversky.param$sym

  switch(type,
         "chisq"    = {output = single01_chisq(confmat,scx,scy,n)},
         "rand"     = {output = single02_rand(pairmat,n)},
         "adjrand"  = {output = single03_adjrand(confmat,scx,scy,n)},
         "fmi"      = {output = single04_fmi(pairmat)},
         "mirkin"   = {output = single05_mirkin(confmat,scx,scy)},
         "jaccard"  = {output = single06_jaccard(pairmat)},
         "pd"       = {output = single07_pd(pairmat)},
         "f"        = {output = single08_f(scx,scy,n)},
         "mhm"      = {output = single09_mhm(confmat,n)},
         "mmm"      = {output = single10_mmm(confmat,n,nk,nl)},
         "vdm"      = {output = single11_vdm(confmat,n)},
         "mi"       = {output = single12_mi(Ixy)},
         "nmi1"     = {output = single13_nmi1(Ixy,Hx,Hy,threps)},
         "nmi2"     = {output = single14_nmi2(Ixy,Hx,Hy,threps)},
         "vi"       = {output = single15_vi(Ixy,Hx,Hy,threps)},
         "wallace1" = {output = single16_wallace1(pairmat,scx)},
         "wallace2" = {output = single17_wallace2(pairmat,scy)},
         "overlap"  = {output = single18_overlap(pairmat)},
         "sdc"      = {output = single19_sdc(pairmat)},
         "smc"      = {output = single20_smc(pairmat)},
         "tanimoto" = {output = single22_tversky(pairmat,1,1,FALSE)},
         "tversky"  = {output = single22_tversky(pairmat,t.alpha,t.beta,t.sym)},
         "jent"     = {output = single23_jent(Pxy)},
         "nmi3"     = {output = single24_nmi3(Hx,Hy,Pxy)},
         "nvi"      = {output = single25_nvi(Hx,Hy,Ixy,threps)}
         )

  # return output
  return(output)
}

## CAT3 : Information Theory
#   12. single12_mi       : Mutual Information
#   13. single13_nmi1     : NMI by Strehl & Ghosh
#   14. single14_nmi2     : NMI by Fred & Jain
#   15. single15_vi       : Variation of Information
#   23. single23_jent     : Joint Entropy
#   24. single24_nmi3     : NMI by Danon
#   25. single25_nvi      : Normalized Variation of Information



# 12. single12_mi ---------------------------------------------------------
#' @keywords internal
#' @noRd
single12_mi <- function(Ixy){
  return(Ixy)
}

# 13. single13_nmi1 -------------------------------------------------------
#' @keywords internal
#' @noRd
single13_nmi1 <- function(Ixy,Hx,Hy,threps){
  correct = min(threps)
  altthr = c(threps,1e-10)
  denom  = sqrt(Hx*Hy)
  if (denom<threps){
    denom = min(altthr)
  }
  output = Ixy/denom

  if (output<correct){output = 0}
  if (output>(1-correct)){output = 1}

  return(output)
}

# 14. single14_nmi2 -------------------------------------------------------
#' @keywords internal
#' @noRd
single14_nmi2 <- function(Ixy,Hx,Hy,threps){
  correct = min(threps)
  altthr = c(threps,1e-10)
  denom  = Hx+Hy
  if (denom<threps){
    denom = min(altthr)
  }
  output = 2*Ixy/denom

  if (output<correct){output = 0}
  if (output>(1-correct)){output = 1}

  return(output)
}

# 15. single15_vi ---------------------------------------------------------
#' @keywords internal
#' @noRd
single15_vi <- function(Ixy,Hx,Hy,threps){
  correct = min(threps)
  # 1. prep
  altthr = c(threps,1e-10)
  if (Hx<threps){
    valx = min(altthr)
  } else {
    valx = Hx
  }
  if (Hy<threps){
    valy = min(altthr)
  } else {
    valy = Hy
  }

  # 2. compute
  output = valx+valy-2*Ixy
  return(output)
}

# 23. single23_jent -------------------------------------------------------
# now from main script, 0-corrected matrix is given
#' @keywords internal
#' @noRd
single23_jent <- function(Pxy){
  # Compute the Value
  output = -sum(Pxy*log2(Pxy))
  return(output)
}

# 24. single24_nmi3 -------------------------------------------------------
#' @keywords internal
#' @noRd
single24_nmi3 <- function(Hx,Hy,Pxy){
  # 1. compute joint entropy from 'single23_jent'
  Hxy = -sum(Pxy*log2(Pxy))
  # 2. compute
  output = (Hx+Hy-Hxy)/((Hx+Hy)/2)
  return(output)
}

# 25. single25_nvi --------------------------------------------------------
#' @keywords internal
#' @noRd
single25_nvi <- function(Hx,Hy,Ixy,threps){
  # 1. prep
  altthr = c(threps,1e-10)
  if (Hx<threps){    Hx = min(altthr)  }
  if (Hy<threps){    Hy = min(altthr)  }

  # 2. compute
  output = (((Hx-Ixy)/Hx) + ((Hy-Ixy)/Hy))/2
  return(output)
}

## CAT2 : Set Overlaps/Matching
#   08. single08_f        : F-Measure
#   09. single09_mhm      : Meila-Heckerman Measure
#   10. single10_mmm      : Maximum-Match Measure
#   11. single11_vdm      : Van Dongen Measure


# 08. single08_f ----------------------------------------------------------
#' @keywords internal
#' @noRd
single08_f <- function(scx,scy,n){
  # # 1. preliminary
  # kk = length(scx)
  # ll = length(scy)
  #
  # # 2. computation
  # output = 0
  # for (i in 1:kk){
  #   tx = scx[i]
  #   vecvaly = (2*tx*scy)/(tx+scy)
  #   output = output + (tx*max(vecvaly))
  # }
  # output = output/n
  # return(output)

  # 1. preliminary
  nx = length(scx)
  ny = length(scy)

  # 2. matrix entries
  fij = array(0, c(nx, ny))
  for (i in 1:nx){
    ci = scx[i]
    for (j in 1:ny){
      cj = scy[j]
      fij[i,j] = 2*ci*cj/(ci+cj)
    }
  }

  # 3. compute
  output = 0
  for (i in 1:nx){
    # output = output + (max(as.vector(fij[i,]))*scx[i]/n)
    output = output + (max(as.vector(fij[i,]))*scx[i]/base::sum(scx))
  }
  return(output)
}

# 09. single09_mhm --------------------------------------------------------
#' @keywords internal
#' @noRd
single09_mhm <- function(confmat, n){
  # 1. get size
  kk = dim(confmat)[1]
  # 2. compute
  output = 0
  for (i in 1:kk){
    output = output+max(confmat[i,])
  }
  output = output/n
  return(output)
}

# 10. single10_mmm --------------------------------------------------------
#' @keywords internal
#' @noRd
single10_mmm <- function(confmat,n,nk,nl){
  # 1. preprocessing
  minsize = min(nk,nl)
  # 2. iteration
  output = 0
  for (i in 1:minsize){
    output = output + max(confmat[i,])
  }
  # 3. return
  output = output/n
  return(output)
}

# 11. single11_vdm --------------------------------------------------------
#' @keywords internal
#' @noRd
single11_vdm <- function(confmat,n){
  # 1. preliminary
  nk = nrow(confmat)
  nl = ncol(confmat)

  # 2. iteration
  output = 2*n
  for (i in 1:nk){
    output = output-max(confmat[i,])
  }
  for (j in 1:nl){
    output = output-max(confmat[,j])
  }
  return(output)
}

#' Measures for Comparing Clusterings
#'
#' Given a set of data points \eqn{D}, a clustering \eqn{C = (C_1,C_2,...,C_k)} is
#' a partition where each pair of sets \eqn{C_i} and \eqn{C_j} has no overlapping
#' elements. \pkg{mclustcomp} package provides a collection of methods that play a
#' role similar to \emph{distance} or \emph{metric}
#' in that measures similarity of two clusterings (or,
#' partitions) \eqn{C} and \eqn{C'}. For a more detailed description,
#' see Meila, M. (2005) <doi:10.1145/1102351.1102424>.
#'
#' @noRd
#' @name mclustcomp-package
#' @import Rdpack
#' @importFrom Rcpp evalCpp
#' @useDynLib mclustcomp
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Compute community size of a clustering
#'
#' @keywords internal
get.commsize <- function(x, ux) {
    .Call('_mclustcomp_getcommsize', PACKAGE = 'mclustcomp', x, ux)
}

#' Comembership matrix of size \code{(2-by-2)}
#'
#' @keywords internal
get.pair <- function(x, y) {
    .Call('_mclustcomp_getpair', PACKAGE = 'mclustcomp', x, y)
}

#' Compute confusion matrix
#'
#' @keywords internal
get.probs <- function(confmat, scx, scy, n, threps) {
    .Call('_mclustcomp_getprobs', PACKAGE = 'mclustcomp', confmat, scx, scy, n, threps)
}

get.confusion <- function(x, y, ux, uy) {
    .Call('_mclustcomp_genconfusion', PACKAGE = 'mclustcomp', x, y, ux, uy)
}

## CAT1 : Counting Pairs
#   01. single01_chisq    : Chi-Squared Coefficient
#   02. single02_rand     : Rand Index
#   03. single03_adjrand  : Adjusted Rand Index
#   04. single04_fmi      : Fowlkes-Mallows Index
#   05. single05_mirkin   : Mirkin Metric
#   06. single06_jaccard  : Jaccard Index
#   07. single07_pd       : Partition Difference
#   16. single16_wallace1 : Wallace Criterion Type 1
#   17. single17_wallace2 : Wallace Criterion Type 2
#   18. single18_overlap  : Overlap Coefficient
#   19. single19_sdc      : Sorensen-Dice Coefficient
#   20. single20_smc      : Simple Matching Coefficient
#   22. single22_tversky  : Tversky Index


# 01. single01_chisq ------------------------------------------------------
#' @keywords internal
#' @noRd
single01_chisq <- function(confmat, scx, scy, n){
  # 1. preliminary
  nx = length(scx)
  ny = length(scy)

  # 2. main computation
  output = 0
  for (i in 1:nx){
    for (j in 1:ny){
      m_ij = confmat[i,j]
      e_ij = scx[i]*scy[j]/n
      output = output+ ((m_ij-e_ij)^2)/e_ij
    }
  }
  return(output)
}

# 02. single02_rand -------------------------------------------------------
#' @keywords internal
#' @noRd
single02_rand <- function(pairmat, n){
  n11 = pairmat[2,2]
  n00 = pairmat[1,1]
  output = (2*(n00+n11))/(n*(n-1))
  return(output)
}

# 03. single03_adjrand ----------------------------------------------------
#' @keywords internal
#' @noRd
single03_adjrand <- function(confmat,scx,scy,n){
  # 1-1. preprocessing
  nk = length(scx)
  nl = length(scy)
  # 1-2. computing basic elements
  t1 = 0
  for (i in 1:nk){
    tx = scx[i]
    t1 = t1+ (tx*(tx-1))/2
  }
  t2 = 0
  for (j in 1:nl){
    ty = scy[j]
    t2 = t2+ (ty*(ty-1))/2
  }
  t3 = (2*t1*t2)/(n*(n-1))
  summ = 0
  for (i in 1:nk){
    for (j in 1:nl){
      tgt = confmat[i,j]
      summ = summ+(tgt*(tgt-1))/2
    }
  }
  # 1-3. gathering up
  output = (summ-t3)/(((t1+t2)/2)-t3)
  return(output)
}

# 04. single04_fmi --------------------------------------------------------
#' @keywords internal
#' @noRd
single04_fmi <- function(pairmat){
  # 4-1. separate
  n11 = pairmat[1,1]
  n01 = pairmat[2,1]
  n10 = pairmat[1,2]
  # 4-2. compute
  output = n11/sqrt((n11+n10)*(n11+n01))
  return(output)
}

# 05. single05_mirkin -----------------------------------------------------
#' @keywords internal
#' @noRd
single05_mirkin <- function(confmat, scx, scy){
  # 1. preliminary
  nk = length(scx)
  nl = length(scy)
  # 2. main iteration
  output = sum((scx^2)) + sum((scy^2))
  for (i in 1:nk){
    for (j in 1:nl){
      tgt = confmat[i,j]
      output = output - (2*(tgt^2))
    }
  }
  return(output)
}

# 06. single06_jaccard ----------------------------------------------------
#' @keywords internal
#' @noRd
single06_jaccard <- function(pairmat){
  # 1. separate
  n11 = pairmat[1,1]
  n01 = pairmat[2,1]
  n10 = pairmat[1,2]
  # 2. compute
  output = n11/(n11+n10+n01)
  return(output)
}


# 07. single07_pd ---------------------------------------------------------
#' @keywords internal
#' @noRd
single07_pd <- function(pairmat){
  output = pairmat[2,2]
  return(output)
}

# 16. single16_wallace1 ---------------------------------------------------
#' @keywords internal
#' @noRd
single16_wallace1 <- function(pairmat, scx){
  n11   = pairmat[1,1]
  denom = sum((scx*(scx-1))/2)
  return(n11/denom)
}

# 17. single17_wallace2 ---------------------------------------------------
#' @keywords internal
#' @noRd
single17_wallace2 <- function(pairmat, scy){
  n11   = pairmat[1,1]
  denom = sum((scy*(scy-1))/2)
  return(n11/denom)
}

# 18. single18_overlap ----------------------------------------------------
#' @keywords internal
#' @noRd
single18_overlap <- function(pairmat){
  x = pairmat[1,1]+pairmat[1,2]
  y = pairmat[1,1]+pairmat[2,1]

  output = pairmat[1,1]/min(x,y)
  return(output)
}

# 19. single19_sdc --------------------------------------------------------
#' @keywords internal
#' @noRd
single19_sdc <- function(pairmat){
  TP = pairmat[1,1]
  FP = pairmat[1,2]
  FN = pairmat[2,1]

  output = (2*TP)/((2*TP)+FN+FP)
  return(output)
}

# 20. single20_smc --------------------------------------------------------
#' @keywords internal
#' @noRd
single20_smc <- function(pairmat){
  output = (sum(diag(pairmat)))/(sum(pairmat))
  return(output)
}

# 22. single22_tversky ----------------------------------------------------
#  Tanimoto Coefficient is special case of Tversky Index with (alpha,beta)=(1,1)
#  alpha=0.5=beta : Dice's Coefficient / SDC
#  alpha=1=beta   : Tanimoto Coefficient
#  sym=FALSE : original tversky
#  sym=TRUE  : a variant introduced on Wikipedia
#' @keywords internal
#' @noRd
single22_tversky <- function(pairmat,alpha,beta,sym){
  TP = pairmat[1,1]
  FP = pairmat[1,2]
  FN = pairmat[2,1]

  if (!sym){
    output = TP/(TP+(alpha*FP)+(beta*FN))
  } else {
    a = min(FP,FN)
    b = max(FP,FN)
    output = TP/(TP+(beta*(alpha*a+(1-alpha)*b)))
  }
  return(output)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get.commsize}
\alias{get.commsize}
\title{Compute community size of a clustering}
\usage{
get.commsize(x, ux)
}
\description{
Compute community size of a clustering
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mclustcomp.R
\name{mclustcomp}
\alias{mclustcomp}
\title{Measures for Comparing Clusterings}
\usage{
mclustcomp(x, y, types = "all", tversky.param = list())
}
\arguments{
\item{x, y}{vectors of clustering labels}

\item{types}{\code{"all"} for returning scores for every available measure.
Either a single score name or a vector of score names can be supplied. See the section
for the list of the methods for details.}

\item{tversky.param}{a list of parameters for Tversky index; \code{alpha} and \code{beta} for
weight parameters, and \code{sym}, a logical where \code{FALSE} stands for original method, \code{TRUE}
for a revised variant to symmetrize the score. Default (alpha,beta)=(1,1).}
}
\value{
a data frame with columns \code{types} and corresponding \code{scores}.
}
\description{
Given two partitions or clusterings \eqn{C_1} and \eqn{C_2}, it returns community comparison scores
corresponding with a set of designated methods. Note that two label vectors should be
of same length having either numeric or factor type. Currently we have 3 classes of methods
depending on methodological philosophy behind each. See below for the taxonomy.
}
\section{Category 1. Counting Pairs}{

\tabular{cl}{
TYPE \tab FULL NAME \cr
\code{'adjrand'}  \tab \href{https://en.wikipedia.org/wiki/Rand_index}{Adjusted Rand index}.\cr
\code{'chisq'}    \tab \href{https://en.wikipedia.org/wiki/Chi-squared_test}{Chi-Squared Coefficient}.\cr
\code{'fmi'}      \tab \href{https://en.wikipedia.org/wiki/Fowlkes-Mallows_index}{Fowlkes-Mallows index}.\cr
\code{'jaccard'}  \tab \href{https://en.wikipedia.org/wiki/Jaccard_index}{Jaccard index}.\cr
\code{'mirkin'}   \tab Mirkin Metric, or Equivalence Mismatch Distance. \cr
\code{'overlap'}  \tab \href{https://en.wikipedia.org/wiki/Overlap_coefficient}{Overlap Coefficient}, or Szymkiewicz-Simpson coefficient.\cr
\code{'pd'}       \tab Partition Difference.\cr
\code{'rand'}     \tab \href{https://en.wikipedia.org/wiki/Rand_index}{Rand Index}.\cr
\code{'sdc'}      \tab \href{https://en.wikipedia.org/wiki/Sorensen-Dice_coefficient}{Sørensen–Dice Coefficient}.\cr
\code{'smc'}      \tab \href{https://en.wikipedia.org/wiki/Simple_matching_coefficient}{Simple Matching Coefficient}.\cr
\code{'tanimoto'} \tab \href{https://en.wikipedia.org/wiki/Jaccard_index}{Tanimoto index}.\cr
\code{'tversky'}  \tab \href{https://en.wikipedia.org/wiki/Tversky_index}{Tversky index}.\cr
\code{'wallace1'} \tab Wallace Criterion Type 1.\cr
\code{'wallace2'} \tab Wallace Criterion Type 2.
}
Note that Tanimoto Coefficient and Dice's coefficient are special cases with (alpha,beta) = (1,1) and (0.5,0.5), respectively.
}

\section{Category 2. Set Overlaps/Matching}{

\tabular{cl}{
TYPE \tab FULL NAME \cr
\code{'f'}   \tab F-Measure. \cr
\code{'mhm'} \tab Meila-Heckerman Measure. \cr
\code{'mmm'} \tab Maximum-Match Measure. \cr
\code{'vdm'} \tab Van Dongen Measure.
}
}

\section{Category 3. Information Theory}{

\tabular{cl}{
TYPE \tab FULL NAME \cr
\code{'jent'} \tab \href{https://en.wikipedia.org/wiki/Joint_entropy}{Joint Entropy} \cr
\code{'mi'}   \tab Mutual Information. \cr
\code{'nmi1'} \tab \href{https://en.wikipedia.org/wiki/Mutual_information}{Normalized Mutual Information} by Strehl and Ghosh. \cr
\code{'nmi2'} \tab \href{https://en.wikipedia.org/wiki/Mutual_information}{Normalized Mutual Information} by Fred and Jain. \cr
\code{'nmi3'} \tab Normalized Mutual Information by Danon et al. \cr
\code{'nvi'}  \tab Normalized Variation of Information. \cr
\code{'vi'}   \tab \href{https://en.wikipedia.org/wiki/Variation_of_information}{Variation of Information}.
}
}

\examples{
## example 1. compare two identical clusterings
x = sample(1:5,20,replace=TRUE) # label from 1 to 5, 10 elements
y = x                           # set two labels x and y equal
mclustcomp(x,y)                 # show all results

## example 2. selection of a few methods
z = sample(1:4,20,replace=TRUE)           # generate a non-trivial clustering
cmethods = c("jaccard","tanimoto","rand") # select 3 methods
mclustcomp(x,z,types=cmethods)            # test with the selected scores

## example 3. tversky.param
tparam = list()                           # create an empty list
tparam$alpha = 2
tparam$beta  = 3
tparam$sym   = TRUE
mclustcomp(x,z,types="tversky")           # default set as Tanimoto case.
mclustcomp(x,z,types="tversky",tversky.param=tparam)


}
\references{
\insertRef{strehl_cluster_2003}{mclustcomp}

\insertRef{meila_comparing_2007}{mclustcomp}

\insertRef{goos_comparing_2003}{mclustcomp}

\insertRef{wagner_comparing_2007}{mclustcomp}

\insertRef{albatineh_similarity_2006}{mclustcomp}

\insertRef{mirkin_eleven_2001}{mclustcomp}

\insertRef{rand_objective_1971}{mclustcomp}

\insertRef{kuncheva_using_2004}{mclustcomp}

\insertRef{fowlkes_method_1983}{mclustcomp}

\insertRef{dongen_performance_2000}{mclustcomp}

\insertRef{jaccard_distribution_1912}{mclustcomp}

\insertRef{li_combining_2010}{mclustcomp}

\insertRef{larsen_fast_1999}{mclustcomp}

\insertRef{meila_experimental_2001}{mclustcomp}

\insertRef{cover_elements_2006}{mclustcomp}

\insertRef{ana_robust_2003}{mclustcomp}

\insertRef{wallace_comment_1983}{mclustcomp}

\insertRef{simpson_mammals_1943}{mclustcomp}

\insertRef{dice_measures_1945}{mclustcomp}

\insertRef{segaran_programming_2007}{mclustcomp}

\insertRef{tversky_features_1977}{mclustcomp}

\insertRef{danon_comparing_2005}{mclustcomp}

\insertRef{lancichinetti_detecting_2009}{mclustcomp}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package-mclustcomp.R
\docType{package}
\name{mclustcomp-package}
\alias{mclustcomp-package}
\title{Measures for Comparing Clusterings}
\description{
Given a set of data points \eqn{D}, a clustering \eqn{C = (C_1,C_2,...,C_k)} is
a partition where each pair of sets \eqn{C_i} and \eqn{C_j} has no overlapping
elements. \pkg{mclustcomp} package provides a collection of methods that play a
role similar to \emph{distance} or \emph{metric}
in that measures similarity of two clusterings (or,
partitions) \eqn{C} and \eqn{C'}. For a more detailed description,
see Meila, M. (2005) <doi:10.1145/1102351.1102424>.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get.confusion}
\alias{get.confusion}
\title{Compute confusion matrix}
\usage{
get.confusion(x, y, ux, uy)
}
\description{
Compute confusion matrix
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get.pair}
\alias{get.pair}
\title{Comembership matrix of size \code{(2-by-2)}}
\usage{
get.pair(x, y)
}
\description{
Comembership matrix of size \code{(2-by-2)}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get.probs}
\alias{get.probs}
\title{Compute confusion matrix}
\usage{
get.probs(confmat, scx, scy, n, threps)
}
\description{
Compute confusion matrix
}
\keyword{internal}
